--[[--------------------------------------------------------------------------------
  ItemSyncCore Parse Framework

  Author:  Derkyle
  Website: http://www.manaflux.com
-----------------------------------------------------------------------------------]]
				
---------------------------------------------------
-- ISync:ParseTooltip
---------------------------------------------------
function ISync:ParseTooltip(sID, sRealmNum, sLinkID)


	--check for primary variable
	if(not sID) then return nil; end

	--check database
	if(not ISyncDB) then return nil; end
	if(not sRealmNum) then return nil; end
	if(not ISyncDB[sRealmNum]) then return nil; end
	if(not ISyncDB[sRealmNum][sID]) then return nil; end
		
				
	local sTipLeft;
	local sTipRight;
	local sParseLink;
	local name_X, link_X, quality_X, minLevel_X, class_X, subclass_X, maxStack_X;
	local itISaPattern;

	sTipLeft = "ISyncTooltipTextLeft";
	sTipRight = "ISyncTooltipTextRight";
	
	--make sure we have tooltip info to work with
	if(not sTipLeft or not sTipRight) then return; end
	
	
	if(sLinkID) then
	
		name_X, link_X, quality_X, minLevel_X, class_X, subclass_X, maxStack_X = GetItemInfo("item:"..sLinkID);
		
		if(subclass_X and ISYNC_TradeSkills and ISYNC_TradeSkills[subclass_X]) then
			itISaPattern = 1;
		end

	end
	
	

	--begin the loop with the amount of lines in the tooltip
	for index = 1, ISyncTooltip:NumLines(), 1 do
		
		--get the tooltip left information
		field = getglobal(sTipLeft..index);
		if( field and field:IsVisible() ) then
			left = field:GetText();
		else
			left = nil;
		end
			
		--get the tooltip right information
		field = getglobal(sTipRight..index);
		if( field and field:IsVisible() ) then
			right = field:GetText();
		else
			right = nil;
		end
				
		--store the pattern
		local sStorePattern = ISync:GetData(sID, "info");
		
	
		--do item locations / weapon locations
		if(left and ISYNC_WeaponLocation[left] ~= nil) then
			
			--when the weapon occasionally shows on the right
			--we need to compensate for this
			
			if(left == ISYNC_CROSSBOW_TEXT) then
			
				--get id
				sParseLink = nil; --reset
				sParseLink = string.gsub(sStorePattern, "^(.-):(.-):(.-):(.-):(.-):(.-):(.-):(.-):(.-):(.-)$", "%4");

			
				--store the special weapon type
				if(not sParseLink or sParseLink == "") then
				
					ISync:SetData(sID, "wt", ISYNC_WeaponTypes[left]);
					
				--if it doesn't match the one stored then update it
				elseif(sParseLink and tonumber(sParseLink) ~= ISYNC_WeaponTypes[left]) then
				
					ISync:SetData(sID, "wt",ISYNC_WeaponTypes[left]);
				end
				
				
			elseif(left == ISYNC_GUN_TEXT) then
			
			
				--get id
				sParseLink = nil; --reset
				sParseLink = string.gsub(sStorePattern, "^(.-):(.-):(.-):(.-):(.-):(.-):(.-):(.-):(.-):(.-)$", "%4");

			
				--store the special weapon type
				if(not sParseLink or sParseLink == "") then
				
					ISync:SetData(sID, "wt", ISYNC_WeaponTypes[left]);
					
				--if it doesn't match the one stored then update it
				elseif(sParseLink and tonumber(sParseLink) ~= ISYNC_WeaponTypes[left]) then
				
					ISync:SetData(sID, "wt",ISYNC_WeaponTypes[left]);
				end
				

			elseif(left == ISYNC_THROWN_TEXT) then
			
			
				--get id
				sParseLink = nil; --reset
				sParseLink = string.gsub(sStorePattern, "^(.-):(.-):(.-):(.-):(.-):(.-):(.-):(.-):(.-):(.-)$", "%4");

			
				--store the special weapon type
				if(not sParseLink or sParseLink == "") then
				
					ISync:SetData(sID, "wt", ISYNC_WeaponTypes[left]);
					
				--if it doesn't match the one stored then update it
				elseif(sParseLink and tonumber(sParseLink) ~= ISYNC_WeaponTypes[left]) then
				
					ISync:SetData(sID, "wt",ISYNC_WeaponTypes[left]);
				end
				

			elseif(left == ISYNC_WAND_TEXT) then
			
			
				--get id
				sParseLink = nil; --reset
				sParseLink = string.gsub(sStorePattern, "^(.-):(.-):(.-):(.-):(.-):(.-):(.-):(.-):(.-):(.-)$", "%4");

			
				--store the special weapon type
				if(not sParseLink or sParseLink == "") then
				
					ISync:SetData(sID, "wt", ISYNC_WeaponTypes[left]);
					
				--if it doesn't match the one stored then update it
				elseif(sParseLink and tonumber(sParseLink) ~= ISYNC_WeaponTypes[left]) then
				
					ISync:SetData(sID, "wt",ISYNC_WeaponTypes[left]);
				end
				
			
			else --it's not a special case
					
				--THIS IS WEAPON LOCATION NOT WEAPON TYPE!
			
				--get id
				sParseLink = nil; --reset
				sParseLink = string.gsub(sStorePattern, "^(.-):(.-):(.-):(.-):(.-):(.-):(.-):(.-):(.-):(.-)$", "%3");

			
				--store the special weapon type
				if(not sParseLink or sParseLink == "") then
				
					ISync:SetData(sID,  "wl", ISYNC_WeaponLocation[left]);
					
				--if it doesn't match the one stored then update it
				elseif(sParseLink and tonumber(sParseLink) ~= ISYNC_WeaponLocation[left]) then
				
					ISync:SetData(sID,  "wl", ISYNC_WeaponLocation[left]);
				end
				
				
			
			end

			
	
		end
	
		--do weapon types
		if(right and ISYNC_WeaponTypes[right] ~= nil) then
			
			
				--get id
				sParseLink = nil; --reset
				sParseLink = string.gsub(sStorePattern, "^(.-):(.-):(.-):(.-):(.-):(.-):(.-):(.-):(.-):(.-)$", "%4");

			
				--store the special weapon type
				if(not sParseLink or sParseLink == "") then
				
					ISync:SetData(sID,  "wt", ISYNC_WeaponTypes[right]);
					
				--if it doesn't match the one stored then update it
				elseif(sParseLink and tonumber(sParseLink) ~= ISYNC_WeaponTypes[right]) then
				
					ISync:SetData(sID, "wt",ISYNC_WeaponTypes[right]);
				end
				
			
		end
		
		
		--grab the level requirement for items or tradeskills
		if(left) then
				_, _, sVariable1 = string.find(left, ISYNC_REQUIRE_FIND);
			
				if( sVariable1 ) then
						
					_, _, sLVLVariable1 = string.find(sVariable1, ISYNC_REQUIRE_FIND2); --check for level requirement
					
					if( sLVLVariable1 ) then
					
					
							--get id
							sParseLink = nil; --reset
							sParseLink = string.gsub(sStorePattern, "^(.-):(.-):(.-):(.-):(.-):(.-):(.-):(.-):(.-):(.-)$", "%8");

							--NEW LVL GRAB (MAKE SURE IT ISN'T A PATTERN (we want to be able to find craftable items using lvlrange)
							if(minLevel_X and not sParseLink or sParseLink == "") then
							
								ISync:SetData(sID,  "level", minLevel_X);
							
							--it doesn't match so store new one
							elseif(minLevel_X and sParseLink and tonumber(sParseLink) ~= minLevel_X) then
							
								ISync:SetData(sID,  "level", minLevel_X);
								
							elseif(minLevel_X and sParseLink and tonumber(sParseLink) == minLevel_X) then
							
								--do nothing otherwise it will loop over and over again cause the bottom two elseif's will check
								--what we parsed, rather what we grabbed with getiteminfo
							
							--store the special weapon type
							elseif(not sParseLink or sParseLink == "") then

								ISync:SetData(sID,  "level", sLVLVariable1);

							--if it doesn't match the one stored then update it
							elseif(sParseLink and tonumber(sParseLink) ~= sLVLVariable1) then

								ISync:SetData(sID, "level",sLVLVariable1);
							end
				

					
					else

						--this is for tradeskill and number required
						
						_, _, sVariable2, sVariable3 = string.find(sVariable1, ISYNC_REQUIRE_FIND3);

						if( sVariable2 and sVariable3 and ISYNC_TradeSkills[sVariable2] ~= nil ) then
							
							
							--get id
							sParseLink = nil; --reset
							sParseLink = string.gsub(sStorePattern, "^(.-):(.-):(.-):(.-):(.-):(.-):(.-):(.-):(.-):(.-)$", "%5");


							--store the special weapon type
							if(not sParseLink or sParseLink == "") then

								ISync:SetData(sID,  "ts", ISYNC_TradeSkills[sVariable2]);

							--if it doesn't match the one stored then update it
							elseif(sParseLink and tonumber(sParseLink) ~= ISYNC_TradeSkills[sVariable2]) then

								ISync:SetData(sID,  "ts", ISYNC_TradeSkills[sVariable2]);
							end
							
							

						end
					

					end--end check for level requirement
		

				end--end variable 1 check
			
						
		end			
			

		
		--do armor types
		if(right and ISYNC_ArmorTypes[right] ~= nil) then
		
		
			--get id
			sParseLink = nil; --reset
			sParseLink = string.gsub(sStorePattern, "^(.-):(.-):(.-):(.-):(.-):(.-):(.-):(.-):(.-):(.-)$", "%6");


			--store the special weapon type
			if(not sParseLink or sParseLink == "") then

				ISync:SetData(sID,  "at", ISYNC_ArmorTypes[right]);

			--if it doesn't match the one stored then update it
			elseif(sParseLink and tonumber(sParseLink) ~= ISYNC_ArmorTypes[right]) then

				ISync:SetData(sID, "at",ISYNC_ArmorTypes[right]);
			end
							

			
		end
		
		
		--do shield types
		if(right and ISYNC_ShieldTypes[right] ~= nil) then
		
			--get id
			sParseLink = nil; --reset
			sParseLink = string.gsub(sStorePattern, "^(.-):(.-):(.-):(.-):(.-):(.-):(.-):(.-):(.-):(.-)$", "%7");


			--store the special weapon type
			if(not sParseLink or sParseLink == "") then

				ISync:SetData(sID,  "st", ISYNC_ShieldTypes[right]);

			--if it doesn't match the one stored then update it
			elseif(sParseLink and tonumber(sParseLink) ~= ISYNC_ShieldTypes[right]) then

				ISync:SetData(sID, "st",ISYNC_ShieldTypes[right]);
			end
			
			
			
		end
		
		
		
	--------------------------------------------------------	
	--------------------------------------------------------		
	end --end for
	--------------------------------------------------------	
	--------------------------------------------------------


end